local core = LibStub("AceAddon-3.0"):GetAddon("tomQuest2")
local module = core:NewModule("soundNotifications", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("tomQuest2")
local defaults = {
	profile = {
		playerObjectiveComplete = true,
		playerQuestComplete = true,
		playerQuestFailed = true,
	},
}

local prdb
function module:OnInitialize()
	self.db = core.db:RegisterNamespace("soundNotifications", defaults, "Default")
	prdb = self.db.profile
end

module.modName = L["Sound Notifications"]
local options
function module:getOptions()
	if not options then
		options = {
			playerObjectiveComplete = {
				name = L["Toggle player quests objectives complete notification"],
				type = "toggle",
				get = function(info)
					return prdb.playerObjectiveComplete
				end,
				set = function(info, value)
					prdb.playerObjectiveComplete = value
				end,
				width = "full",
				order = 10,
			},
			playerQuestComplete = {
				name = L["Toggle player quests complete notification"],
				type = "toggle",
				get = function(info)
					return prdb.playerQuestComplete
				end,
				set = function(info, value)
					prdb.playerQuestComplete = value
				end,
				width = "full",
				order = 11,
			},
			playerQuestFailed = {
				name = L["Toggle player quests failed notification"],
				type = "toggle",
				get = function(info)
					return prdb.playerQuestFailed
				end,
				set = function(info, value)
					prdb.playerQuestFailed = value
				end,
				width = "full",
				order = 12,
			},
		}
	end
	return options
end

function module:OnEnable()
	core.RegisterCallback(self, "playerQuestObjectiveProgress")
	core.RegisterCallback(self, "playerQuestComplete")
	core.RegisterCallback(self, "playerQuestFailed")
end

function module:OnDisable()
	core.UnregisterAllCallbacks(self)
end

function module:playerQuestObjectiveProgress(event, firstRun, commHandler, uid, objective, got, ngot)
	if ngot == core.questsObjectives[uid][objective].nneed and prdb.playerObjectiveComplete and not firstRun then
		PlaySound[[Sound\Creature\Peon\PeonReady1.wav]]
	end
end

function module:playerQuestComplete(event, firstRun, commHandler, uid)
	if prdb.playerQuestComplete and not firstRun then
		PlaySoundFile([[Interface\Addons\tomQuest2\media\Peasant_work_done.mp3]])
	end
end

function module:playerQuestFailed(event, firstRun, commHandler, uid)
	if prdb.playerQuestFailed and not firstRun then
		PlaySound([[Sound\Interface\igPlayerBind.wav]])
	end
end